// Type definitions for jquery-migrate 3.1
// Project: https://github.com/jquery/jquery-migrate
// Definitions by: Piotr Błażejewicz (Peter Blazejewicz) <https://github.com/peterblazejewicz>
// Definitions: https://github.com/DefinitelyTyped/DefinitelyTyped

/// <reference types="jquery" />

interface JQueryStatic {
    /**
     * An array of string warning messages that have been generated by the code on the page,
     * in the order they were generated. Messages appear in the array only once,
     * even if the condition has occurred multiple times, unless jQuery.migrateReset() is called
     * @default []
     */
    migrateWarnings: string[];

    /**
     * Set this property to `true` to prevent console warnings from being generated in the development version.\
     * The `jQuery.migrateWarnings` array is still maintained when this property is set,
     * which allows programmatic inspection without console output
     * @default false
     */
    migrateMute: boolean;

    /**
     * Set this property to `false` if you want warnings
     * but do not want stack traces to appear on the console.
     * @default true
     */
    migrateTrace: boolean;

    /**
     * Indicates the version of Migrate in use
     */
    readonly migrateVersion: string;

    /**
     * This method clears the `jQuery.migrateWarnings` array and "forgets" the list of messages
     * that have been seen already.
     */
    migrateReset(): void;
}
